# "@(#)Makefile.param.t 3.2 9/21/90 Arthur van Hoff (Turing Institute)"

# Top-level HyperNeWS1.4 Makefile.param
# Contains parameters used by all Makefiles during HyperNeWS installation

# Generate automatic dependencies
.KEEP_STATE:

# Commands
RM = /bin/rm -f
CC = /bin/cc
CP = /bin/cp
INSTALL = install
MAKE = make

# Beginning of macros added by Config - SEDFLAG
# End of macros added by Config

# Temporary files to remove when cleaning
TEXTMPFILES = *.aux *.dvi *.lof *.toc *.dvi-log *.log *.out
CTMPFILES = *.o *.s core a.out lex.yy.c y.tab.c ,* .make.state
TMPFILES = $(TEXTMPFILES) $(CTMPFILES)

# HyperNeWS stuff
HNINCL = -I$(HNSRC)/include
HNLIB = -L$(HNSRC)/lib/intf -lhn
CURSORFONT = HyperNeWSCursor
NCURSORFONT = HpNWSC

# C compiler stuff
CINCL =
CFLAGS = 
CPSLIB = -L$(OPENWINHOME)/lib -lcps
CPSINCL= -I$(OPENWINHOME)/include

# Handy make commands
SUBDIRSALL =  @ for i in $(SUBDIRS) ; do \
		echo "Making subdirectory $$i"; \
		(cd $$i ; $(MAKE) all) ; \
	done

SUBDIRSINSTALL =  @ for i in $(SUBDIRS) ; do \
		echo "Installing subdirectory $$i"; \
		(cd $$i ; $(MAKE) install) ; \
	done

SUBDIRSCLEAN = @ for i in $(SUBDIRS) ; do \
		echo "Cleaning subdirectory $$i"; \
		(cd $$i ; $(MAKE) clean) ; \
	done

# This next line avoids confusion with multiple architectures
LD_LIBRARY_PATH=

.SUFFIXES: .c .o
.c.o:
	$(CC) $(CPPFLAGS) $(CFLAGS) $(CINCL) -c $<

# cps dependencies
.SUFFIXES: .cps

.cps.h:
	$(OPENWINHOME)/bin/cps < $< > $@
