/* Copyright (c) The Turing Institute 1989 */

#ifndef lint
static char sccsid[] = "@(#)hash.c 3.1 3/19/90 Tim Niblett (Turing Institute)";
#endif lint

#include <stdio.h>
#include <string.h>
#include <hypernews.h>
#include <malloc.h>

/* Hash table access to hn_any objects from names */

/*
 * In general we might want to access by two keys
 * the stack and the name.  I have implemented a
 * single key lookup, in the hope that it will be
 * adequate.
 * It should also be noted that you can't delete entries
 * from the table.  This would be necessary if you wanted
 * a hook-up to HyperNeWS which contained dynamic info.
 * about objects.
 */

/* Should be a prime */
#define HASHSIZE	383

typedef struct entry {
	hn_any *object;
	struct entry *link;
	char name[1];
} entry;

static entry *hashtable[HASHSIZE];

static int hash(s)
register char *s;
{
	register int len;

	switch (len = strlen(s)) {
	case 0:
		return 0;
	case 1:
		return (s[0] * 379) % HASHSIZE;
	case 2:
		return ((s[0] * 379) + (s[1] * 277)) % HASHSIZE;
	default:
		return ((s[0] * 577) + 
			(s[len>>1] * 313) +
			(s[len-1] * 409) +
			(len * 593))
				% HASHSIZE;
	}
}

hn_any *intern(s, e)
register char *s;
hn_any *e;
{
        register int h, len = strlen(s);
	register entry *p;
	char *strcpy();
 
 	h = hash(s);
	p =  hashtable[h];
	while (p != NULL)
		if (strcmp(s, p->name) == 0)
		 	return(p->object);
		 else
			p = p -> link;
	p = (entry *)malloc((unsigned)(sizeof(entry) + len));
	strcpy(p->name, s);
	p->object = e;
	p->link = hashtable[h];
	hashtable[h] = p;
	return(p->object);
}
