/* "@(#)readfile.h 3.1 3/19/90 Tim Niblett (Turing Institute)"; */

#define LEAF(doc)	((doc) -> child == 0)
#define CHILD(doc)	((doc) -> child)
#define SIB(doc)	((doc) -> sib)
#define PRESIB(doc)	((doc) -> presib)
#define PARENT(doc)	((doc) -> parent)
#define TEXT(doc)	((doc) -> contents)
#define LABEL(doc)	((doc) -> label)
#define TITLE(doc)	((doc) -> title)
#define DOCSET(doc)	doc_hash((doc), 1)
#define DOCSEE(doc)	doc_hash((doc), 0)

typedef struct Document {
	char * label;
	char *title;
	char ** contents;
	struct Document *child;
	struct Document *parent;
	struct Document *sib;
	struct Document *presib;
} Document;


extern Document *get_to_node( /* char * */ );
extern char *next_section( /* char * */ );
extern char *prev_section( /* char * */ );
extern char *up_section( /* char * */ );
extern void	read_in_doc();
extern void doc_hash_init();
extern Document *doc_hash();
extern Document *doc_find(/* char * */);
extern Document *root;

