#ifndef lint
static char sccsid[] = "@(#)rk.c 3.1 3/19/90 Tim Niblett (Turing Institute)";
#endif lint

/* Reasonably fast string matching (exact)
 * to find occurrences of a word in a document
 */

#include "mactype.h"

#include <stdio.h>
#include <ctype.h>

#ifdef MAC
#include <strings.h>
#include <unix.h>
#include <storage.h>
#endif

#define PRIME	33554393L
#define DP		32L
/*
 *	search(target, string) returns string in target or NULL
 */
 
 char *search(pattern, target)
 char *pattern, *target;
 {
 	register long h1, h2, dM, plen = strlen(pattern), i;
 	register char *p, *t;
 	
 	if (plen > strlen(target))
 		return(NULL);
 		
 	for (dM = 1, i = 1; i < plen; i++)
 		dM = (dM * DP) % PRIME;
 		
 	for (h1 = 0, p = pattern, i = 0; i < plen; i++, p++)
 		h1 = ((h1 << 5) + (long)*p) % PRIME;
 		
  	for (h2 = 0, t = target, i = 0; i < plen; i++, t++)
 		h2 = ((h2 << 5) + (long)*t) % PRIME;
 	
 	p = target;
 	t = (target+plen);
 	while ( h1 != h2 && *t ) {
 		h2 = (h2 + (PRIME << 5) - (long)*p++ *dM) % PRIME;
 		h2 = ((h2 << 5) + (long)*t++) % PRIME;
 	}
 	if (h1 == h2) 
		return(p); 
	else 
		return(NULL);
 }
