
#ifndef lint
static char sccsid[] = "@(#)display.c 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif lint

#include <stdio.h>
#include "default.h"
#include "screen.h"


#define WINRESIZE	0200
#define WINDESTROY	0201
#define WININVERT	0202
#define WINSCROLL	0203
#define	FLASHON		0204
#define	SELECTIONON	0205

extern 	int	fontsize, xpos, ypos, width, height, Mfd, change_tty_size(),
		upd_scroll, his_top, his_siz, history, closebox, resizebox,
		selection, fixed, iconx, icony, iconic, cursor_vis;
extern	char	*his_line();

int	window_open = 0, rows = 24, cols = 80,
	col = 0 , row = 0, save_row, save_col,
	scroll_from = 0, scroll_to = 24, 
	invert = 0, old_row = 0, old_col = 0;

flush_output()
{
	flush_screen();
	flush_history();
	show_cursor();
	hn_flush();
}

show_cursor()
{
	if ((row+his_top) < rows) {
		if ((old_row != (row+his_top)) || (old_col != col)) {
			MoveTo(row+his_top,col);
			old_row = (row+his_top);
			old_col = col;
		}
		if (!cursor_vis) {
			cursor_vis = 1;
			DrawCursor();
			draw_selection();
		}
	}
}

hide_cursor()
{
	if (cursor_vis) {
		DrawCursor();
		cursor_vis = 0;
	}
}

screen_cr()
{
	screen_moveto(row,0);
}

screen_lf()
{
	if ((row+1) > scroll_to) {
		scroll_screen(1,scroll_from,scroll_to);
		screen_ensure_pos(row,col);
	} else
		screen_moveto(row+1,col);
}

screen_tab()
{
	int	n = TABWIDTH - (col % TABWIDTH);

	screen_moveto(row,min(cols,col+n));
}

screen_ascii(c)
char c;
{
	/* output a single ascii character */
	if (col >= cols) {
		screen_cr();
		screen_lf();
	}
	screen_put((c|invert),row,col);
	col++;
}

screen_bell()
{
	flush_screen();
	flush_history();
	tty_bell();
	hn_flush();
}

screen_reverse(flag)
{
	if (flag)
		invert = 0200;
	else
		invert = 0;
}

screen_moveto(r,c)
{
	r = min(r,rows-1);
	c = min(c,cols);
	screen_ensure_pos(r,c);
	row = r;
	col = c;
}

screen_rmoveto(rrow,rcol)
{
	if ((row+rrow) < 0) rrow = -row;
	if ((col+rcol) < 0) rcol = -col;
	screen_moveto(row+rrow,col+rcol);
}

screen_save_cursor()
{
	save_row = row;
	save_col = col;
}

screen_restore_cursor()
{
	screen_moveto(save_row,save_col);
}

screen_scroll_forward()
{
	scroll_screen(1,scroll_from,scroll_to);
}

screen_scroll_back()
{
	scroll_screen(-1,scroll_from,scroll_to);
}

screen_change_scroll(from,to)
{

	if ((from == scroll_from) && (to == scroll_to))
		return;
	flush_screen();
	scroll_to = min(to,rows-1);
	scroll_from = max(scroll_to - (to-from),0);
}

screen_clear()
{
	int	from;

	clear_screen(0,rows-1);
	selection = 0;
	ClearScreen();
	MoveTo(0,0);
	upd_scroll = 0;
	old_row = row = 0;
	old_col = col = 0;
}

screen_clear_eod()
{
	int	i = row;
	
	while (i < rows)
		screen_put('\0',i++,0);
}

screen_clear_eoln()
{
	screen_put('\0',row,col);
}

screen_add_line()
{
	int	t = scroll_from;
	/* scroll the screen to add a line at the current cursor position */
	screen_change_scroll(row,scroll_to);
	scroll_screen(-1,row,scroll_to);
	screen_change_scroll(t,scroll_to);
}

screen_delete_line()
{
	int	t = scroll_from;
	/* scroll the screen to delete a line at the current cursor position */
	screen_change_scroll(row,scroll_to);
	scroll_screen(1,row,scroll_to);
	screen_change_scroll(t,scroll_to);
}

screen_insert_char()
{
	screen_ic(row,col);
}

screen_delete_char()
{
	screen_dc(row,col);
}
