
#ifndef lint
static char sccsid[] = "@(#)history.c 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif lint


#include <stdio.h>
#include "screen.h"
#include "hnterm.h"

extern	int old_row, old_col, selection;
char	**his = NULL, *stralloc();
int	his_len	= 0,
	his_siz = 0,
	his_first = 0,
	his_end = 0,
	his_on = 1,
	his_top = 0;

set_history(flag)
{
	if (!his_len)
		return;
	his_on = flag;
	if (!flag) {
		history_reset();
		hn_flush();
		ScrollRange(0,0,0);
	} else
		ScrollRange(0,his_siz-his_top,his_siz);
}

alloc_history(len)
{
	char	**p;

	p = his = (char **)malloc(len*sizeof(char *));
	his_len = len;
	while (len--)
		*p++ = NULL;
}

flush_history()
{
	if (his_len && (his_end != his_siz)) {
		ScrollRange(0,his_siz-his_top,his_siz);
		his_end = his_siz;
	}
}

add_history(str)
char	*str;
{
	if ((!his_len) || (!his_on))
		return;
	his_first = (his_first + 1) % his_len;
	if (his[his_first] != NULL)
		free(his[his_first]);
	his[his_first] = stralloc(str);
	if ((his_siz+1) < his_len)
		his_siz++;
}

char *
stralloc(str)
{
	char *p = (char *)malloc(strlen(str)+1);
	strcpy(p,str);
	return(p);
}

char *
his_line(n)
{
	int	i;

	if (n < his_top) {
		return(his[(his_first + his_len -
			    (his_top-n-1)) % his_len]);
	} else
		return(screen[n-his_top].ln);
}

history_reset()
{
	if (his_len) {
		ScrollValue(his_siz);
		history_scroll(his_siz);
	}
}

putline(row,ln)
char *ln;
{
	int	len = strlen(ln);

	if (len < cols)
		reprint_line(row,len,ln);
	else
		reprint_part(row,0,cols,ln);
}

history_scroll(n)
{
	int	i, j;

	n = his_siz - n;
	if (his_top == n)
		return;

	begin();
	undo_selection();
	hide_cursor();
	i = his_top - n;
	his_top = n;
	if ((abs(i)+1) < rows) {
		/* scroll portion of the screen */
		if (selection) {
			UndoSelection();
			selection = 0;
		}
		ScrollLines(i,0,rows-1);
		if (i > 0) {
			for (j = rows - i ; j < rows ; j++)
				putline(j,his_line(j));
		} else {
			for (j = 0 ; j < abs(i) ; j++)
				putline(j,his_line(j));
		}
	} else {
		/* clear the screen */
		selection = 0;
		ClearScreen();
		old_row = old_col = 0;
		for (i = 0 ; i < rows ; i++)
			putline(i,his_line(i),((i+1) < rows));
	}
	show_cursor();
	end();
	hn_flush();
}
