%{
#ifndef lint
static char sccsid[] = "@(#)parse.vt100.l 3.3 10/4/90 Arthur van Hoff (Turing Institute)";
#endif lint


	/* vt100 terminal capabillities */

#include	"screen.h"

	char	*terminal_name = "vt100";
	char 	*yygetarg();
	int	yycol, yyrow;
%}

%%
"\033[2J"* 			{ screen_clear(); }

"\033[?1h\033="*		{ set_history(0); }
"\033[?1l\033>"*		{ set_history(1); }

"\033[4m"*			{ screen_reverse(1); }
"\033[1m"*			{ screen_reverse(1); }
"\033[7m"*			{ screen_reverse(1); }
"\033[5m"*			{ screen_reverse(1); }
"\033[m"*			{ screen_reverse(0); }

"\033[H"*			{ screen_moveto(0,0); }
"\033[;H"*			{ screen_moveto(0,0); }
"\033[A"*			{ screen_rmoveto((int)((-strlen(yytext))/3),0); }
"\033[C"*			{ screen_rmoveto(0,(int)(strlen(yytext)/3)); }
"\033["[0-9]*";"[0-9]*"H"	{ yygetarg(yygetarg(yytext+2,&yyrow)+1,&yycol);
				  screen_moveto(yyrow-1,yycol-1); }

"\033["[0-9]+"B"		{ yygetarg(yytext+2,&yyrow);
				  screen_rmoveto(yyrow,0); }
"\033["[0-9]+"A"		{ yygetarg(yytext+2,&yyrow);
				  screen_rmoveto(-yyrow,0); }

"\033[J"*			{ screen_clear_eod(); }
"\033[K"*			{ screen_clear_eoln(); }

"\033D"				{ screen_scroll_forward(); }
"\033M"				{ screen_scroll_back(); }
"\033["[0-9]*";"[0-9]*"r"	{ yygetarg(yygetarg(yytext+2,&yyrow)+1,&yycol);
				  screen_change_scroll(yyrow-1,yycol-1); }

"\033""7"			{ screen_save_cursor(); }
"\033""8"			{ screen_restore_cursor(); }

\011				{ screen_tab(); }
"\007"*				{ screen_bell(); }
\012				{ screen_lf(); }
\015				{ screen_cr(); }
"\010"*				{ screen_rmoveto(0,-strlen(yytext)); }
.				{ screen_ascii(*yytext); }

%%

char *
yygetarg(p,c)
char *p;
int  *c;
{
	*c = atoi(p);
	return((*c < 10) ? (p+1) : ((*c < 100) ? (p+2) : (p+3)));
}
