
#ifndef lint
static char sccsid[] = "@(#)signal.c 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif lint

#include <stdio.h>
#include <sgtty.h>
#include <sys/wait.h>
#include <signal.h>

extern int	pgrp, persist;

send_signal(sig,code,scp)
int	sig, code;
struct	sigcontext *scp;
{
	if (pgrp != 0)
		killpg(pgrp,sig);
}

child_died(sig,code,scp)
int	sig, code;
struct	sigcontext *scp;
{
	union	wait status;
	int	pid = wait3(&status,WNOHANG,0);

	if (pid < 0)
		perror("child died with but no status recieved","");
	else {
		if (persist == 0) {
			quit();
			cleanup_tty();
			exit(0);
		}
	}
}

/*	signal handlers 	*/

struct {
	int	sig;
	int	(*proc)();
} handlers[] = {
	{SIGINT,	send_signal},
	{SIGQUIT,	send_signal},
	{SIGSTOP,	send_signal},
	{SIGTSTP,	send_signal},
	{SIGCONT,	send_signal},
	{SIGHUP,	send_signal},
	{SIGCHLD,	child_died}
};

init_signal()
{
	int	i;

	for (i = 0 ; i < (sizeof(handlers)/sizeof(handlers[0])) ; i++)
		signal(handlers[i].sig,handlers[i].proc);
}
