#ifndef lint
static char sccsid[] = "@(#)utmp.c 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/timeb.h>
#include <sys/file.h>
#include <utmp.h>
#include <pwd.h>

extern long lseek();

#define SCPYN(a,b)	strncpy(a,b,sizeof(a))
#define SCMPN(a,b)	strncmp(a,b,sizeof(a))

static	char utmpf[] = "/etc/utmp";
static	int tslot = -1;
static	struct utmp utmp;

add_utmp(terminal)
char 	*terminal;
{
	struct passwd *pw;
	int i;

	/*
	* Record entry in /etc/utmp if possible.
	*/
	tslot = ttyslot();
	pw = getpwuid(getuid());
	if ((ttyslot > 0) && pw && (i = open(utmpf,O_RDWR)) >= 0) {
		char *cp, *p, *getenv(), *index();

		bzero(&utmp,sizeof(utmp));

		/* just add the terminal name */
		if (*terminal == '/')
			terminal += 5;
		SCPYN(utmp.ut_line,terminal);

		SCPYN(utmp.ut_name,pw->pw_name);

		/* get the host name */
		if ((cp = getenv("NEWSSERVER")) == NULL)
			cp = "";
		for (; *cp && (*cp != ';') ; cp++);
		if (*cp == ';')
			cp++;
		SCPYN(utmp.ut_host,cp);

		time(&utmp.ut_time);
		/* append to the end of file */
		lseek(i,tslot * sizeof(utmp),L_SET);
		write(i,&utmp,sizeof(utmp));
		close(i);
	}
}

rm_utmp()
{
	int fd;

	if (tslot >= 0 && (fd = open(utmpf,O_WRONLY)) >= 0) {
		bzero(&utmp,sizeof(utmp));
		lseek(fd,tslot * sizeof(utmp),L_SET);
		write(fd,&utmp,sizeof(utmp));
		close(fd);
		tslot = -1;
	}
}
