
% "@(#)hnps.cps 3.2 9/21/90 Arthur van Hoff (Turing Institute)";


cdef hnps_start(string program, int pid, int intro)
	% startup HyperNeWS
	(HNHOME) getenv (/etc/HyperNeWS/init.ps) append run

	% define tokens
	/Send cvx 1 setfileinputtoken
	/ShowStack cvx 2 setfileinputtoken
	/HideStack cvx 3 setfileinputtoken
	/FindStack cvx 4 setfileinputtoken
	/FindObject cvx 5 setfileinputtoken
	/PrintClient cvx 6 setfileinputtoken
	/nullarray cvx 7 setfileinputtoken
	
	% make sure we get error messages
	/errordict 32 dict begin ErrorList {
		[1 index] {
			Stopped? {pop pop stop} {
				2 copy DEBUG DEBUG
				clienterror
			} ifelse
		} append cvx def
	} forall currentdict end def

	% setup correct context
	/OperandStack [currentfile NIL /unkown currentfile dup NIL] def
	/Self currentfile def
	/MyStack null def
	program pid ConnectClient

	intro 0 eq{[/SystemCard] /GotoCard /system FindStack Send} if
	% write a sync message
	currentfile 12 128 or write
	currentfile flushfile

cdef hnps_stop()
	DisconnectClient

cdef hnps_put()
	put
cdef hnps_get()
	get
cdef hnps_checknull()
	null eq
cdef hnps_null()
	null
cdef hnps_true()
	true
cdef hnps_false()
	false
cdef hnps_name(string s)
	s cvn
cdef hnps_string(string s)
	s
cdef hnps_float(float f)
	f
cdef hnps_integer(int i)
	i
cdef hnps_begin_array()
	mark
cdef hnps_end_array()
	]

cdef hnps_set_canvas()
	% canvasobject
	begin
		MyCanvas setcanvas initgraphics
		FontName findfont FontSize scalefont setfont
		Color SetColor
	end

cdef hnps_set_draw()
	% string buttonobject
	begin
		ExtendFileName run
		/DrawingData exch store
		/ButtonType /Drawing store
		NIL /Update Self Send
	end

cdef hnps_rename()
	% name nonstackobject
	dup 3 1 roll ReNameObject

cdef hnps_stack_copy()
	% name
	NewStackCopy not {null} if

cdef hnps_show_error()
	% text
	ShowError
