#include <stdio.h>
#include <hypernews.h>

hn_any *mystack;

int myhandler(any,argc,argv)
hn_any	*any,*argv[];
int	argc;
{
	int	xint,yint;
	hn_any	*xany,*yany,*myargs;

	xint = argv[0]->u.number;
	yint = argv[1]->u.number;
	xany = hn_new_number((double) xint);
	yany = hn_new_number((double) yint);
	myargs = hn_new_array(xany,yany,NULL);
	hn_send(mystack,"Move",myargs);
	hn_free(myargs);
	return 1;
}

int creep()
{
	hn_any	*myargs,*xany,*yany;
	int	xint,yint;

	xany = hn_get(mystack,"ScreenX");
	yany = hn_get(mystack,"ScreenY");
	xint = xany->u.number + 40;
	yint = yany->u.number + 40;
	myargs = hn_new_array(hn_new_number((double) xint),
		hn_new_number((double) yint),NULL);
	hn_send(mystack,"Move",myargs);
	hn_free(myargs);
	return 1;
}

int debug(any,argc,argv)
hn_any	*any,*argv[];
int	argc;
{
	fprintf(stderr,"Message received by client: /%s\n",
		any->u.message.name);
	return 0;
}

main(argc,argv)
int	argc;
char	**argv;
{
	if (!hn_start(argv[0])) {
		fprintf(stderr,"creeper: hn_start() failed.\n");
		exit(1);
	}
  
	/* Define the interface objects */
	mystack = hn_new_object((char *) NULL,hn_Stack,"Creeper");

	/* Register the messages */
	hn_register(debug,hn_new_message(ANY,ANY,ANY));
	hn_register(myhandler,
		hn_new_message(ANY,"MoveIt",hn_new_array_body(2)));
	hn_register(creep,hn_timeout);
	hn_register(hn_stop,hn_quit);

	/* Connect to the stack */
	hn_connect(mystack);

	/* Wait for messages */
	hn_listen(5000);  

	exit(0);
}
