
#ifndef lint
static char sccsid[] = "@(#)genps.c 3.2 5/17/90 Arthur van Hoff (Turing Institute)";
#endif lint


#include	<stdio.h>
#include	<sys/file.h>
#include	<math.h>
#include	<pixrect/pixrect_hs.h>
#include	"psdata.h"
#include	"hipl_format.h"

#define TEXSCALEH	1.01
#define TEXSCALEV	1.066
#define LWSCALE	0.82
#define LWCENTERX	(18.0+((593.76-18.0)/2.0))
#define LWCENTERY	(3.12+((789.12-3.12)/2.0))

#define	NCOLS	256

#define	POINT2ANG(x,y)	((atan2(y,x) * 180.0) / 3.1415927)
#define abs(x)		(((x) < 0) ? (-(x)) : (x))
#define max(x,y)		(((x) > (y)) ? (x) : (y))
#define min(x,y)		(((x) < (y)) ? (x) : (y))

#define POINTX(n)	(pts->val.arr->val[(n+i)%i]->val.arr->val[0]->val.floatval)
#define POINTY(n)	(pts->val.arr->val[(n+i)%i]->val.arr->val[1]->val.floatval)
#define BETWEENX(a,b)	(POINTX(a) + ((POINTX(b)-POINTX(a))/2.0))
#define BETWEENY(a,b)	(POINTY(a) + ((POINTY(b)-POINTY(a))/2.0))


int	connect = 0;
struct psobject *theobject;
int lwoutput = 1, texoutput = 0, pictalso = 1, pureps = 0,
    rgbout = 0, errlib = 0;
double	hscale, vscale, extrascale = 1.0;

struct psobject *ps_get();
extern char *get_color();

generate_ps(f)
FILE *f;
{
	double	x, y, w, h;

	theobject = pop();

	if (theobject->type != DICT) {
		fprintf(stderr,"Object type error\n");
		exit(-1);
	}
	w = ps_get(theobject,"w",FLOAT)->val.floatval;
	h = ps_get(theobject,"h",FLOAT)->val.floatval;
	if (texoutput) {
		lwoutput = 1;
		hscale = TEXSCALEH;
		vscale = TEXSCALEV;
		fprintf(f,"%%!PS-HyperNeWS drawing-\n");
		fprintf(f,"%%%%Creator:%s\n",getenv("USER"));
		fprintf(f,"%%%%Title:HyperNeWS drawing.\n");
		fprintf(f,"%%%%BoundingBox:0 0 %g %g\n",
			w*hscale,h*vscale);
		fprintf(f,"%%%%TemplateBox:0 0 %g %g\n",
			w*hscale,h*vscale);
		fprintf(f,"%%%%EndComments\n");
		load_drawlib(f);
		fprintf(f,"gsave initclip\n");
		fprintf(f,"%.3f %.3f scale\n",hscale,vscale);
	} else if (lwoutput) {
		hscale = LWSCALE*extrascale;
		vscale = LWSCALE*extrascale;
		fprintf(f,"%%!PS-HyperNeWS drawing-\n");
		fprintf(f,"%%%%Creator:%s\n",getenv("USER"));
		fprintf(f,"%%%%Title:HyperNeWS drawing.\n");
		if (pureps) {
			fprintf(f,"%%%%BoundingBox:0 0 %g %g\n",w,h);
			fprintf(f,"%%%%TemplateBox:0 0 %g %g\n",w,h);
		} else {
			x = LWCENTERX - ((w/2.0)*LWSCALE*extrascale);
			y = LWCENTERY - ((h/2.0)*LWSCALE*extrascale);
			fprintf(f,"%%%%BoundingBox:%g %g %g %g\n",x,y,
				x+(w*hscale),y+(h*vscale));
			fprintf(f,"%%%%TemplateBox:%g %g %g %g\n",x,y,
				x+(w*hscale),y+(h*vscale));
		}
		fprintf(f,"%%%%EndComments\n");
		fprintf(f,"save /psnewssav exch def\n");
		/* translate the drawing to the center of the paper */
		load_drawlib(f);
		
		if (pureps)
			fprintf(f,"gsave\n");
		else {
			fprintf(f,"gsave initmatrix");
			fprintf(f," %.3f %.3f translate\n",
				x,y);
			fprintf(f,"%.3f %.3f scale\n",hscale,vscale);
		}
	} else {
		fprintf(f,"%%!PS-HyperNeWS drawing-\n");
		fprintf(f,"%%%%Creator:%s\n",getenv("USER"));
		fprintf(f,"%%%%Title:HyperNeWS drawing.\n");
		fprintf(f,"%%%%BoundingBox:0 0 %g %g\n",w,h);
		fprintf(f,"%%%%TemplateBox:0 0 %g %g\n",w,h);
		fprintf(f,"%%%%EndComments\n");
		fprintf(f,"1 setlinequality\n");
		hscale = 1.0;
		vscale = 1.0;
	}
	generate_drawing(f,theobject);
	if (texoutput) {
		fprintf(f,"grestore\n");
	} else if (lwoutput) {
		if (pureps)
			fprintf(f,"grestore psnewssav restore\n");
		else
			fprintf(f,"showpage grestore psnewssav restore\n");
	}
	unuse_object(theobject);
}

generate_code(f,p)
FILE *f;
struct psobject *p;
{
	struct psobject *q;
	struct psobject *m;
	char *type;
	double	oldhscale = hscale, oldvscale = vscale;

	if (p->type != DICT) {
		fprintf(stderr,"Member type error\n");
		exit(-1);
	}

	/* generate code for this object */
	type = ps_get(p,"Type",NAME)->val.str;
	/* fprintf(f,"%% type: %s\n",type); */
	pr_object(f,ps_get(p,"Matrix",ARRAY));
	if (connect)
		fprintf(f," CM\n");
	else
		fprintf(f," BO\n");
	hscale = 0;
	vscale = 0;
	if (!strcmp(type,"Drawing")) 
		generate_drawing(f,p);
	else if (!strcmp(type,"DrawRect")) 
		generate_rect(f,p);
	else if (!strcmp(type,"DrawRRect")) 
		generate_rrect(f,p);
	else if (!strcmp(type,"DrawLine")) 
		generate_line(f,p);
	else if (!strcmp(type,"DrawText")) 
		generate_text(f,p);
	else if (!strcmp(type,"DrawPie")) 
		generate_pie(f,p);
	else if (!strcmp(type,"DrawPoly")) 
		generate_poly(f,p);
	else if (!strcmp(type,"DrawSpline")) 
		generate_spline(f,p);
	else if (!strcmp(type,"DrawArc")) 
		generate_arc(f,p);
	else if (!strcmp(type,"DrawPict")) 
		generate_pict(f,p);
	else if (!strcmp(type,"DrawEPS")) 
		generate_eps(f,p);
	else if (!strcmp(type,"DrawOval")) 
		generate_oval(f,p);
	else fprintf(f,"%% UNKNOWN OBJECT TYPE\n");

	if (connect)
		fprintf(f,"SM\n");
	else
		fprintf(f,"EO\n");

	hscale = oldhscale;
	vscale = oldvscale;
}

load_errlib(f)
register FILE *f;
{
	register FILE *ofp;
	register char c;
	char fname[256];

	strncpy(fname,getenv("HNHOME"),256);
	strncat(fname,ERRLIB,256);

	if ((ofp = fopen(fname,"r")) == NULL) {
		fprintf(stderr,"cannot open: %s\n",fname);
		exit(-1);
	}
	while ((c = getc(ofp)) != EOF)
		putc(c,f);
	fclose(ofp);
}

load_drawlib(f)
register FILE *f;
{
	register FILE *ofp;
	register char c;
	char fname[256];

	if (errlib)
		load_errlib(f);
	strncpy(fname,getenv("HNHOME"),256);
	strncat(fname,DRAWLIB,256);

	if ((ofp = fopen(fname,"r")) == NULL) {
		fprintf(stderr,"cannot open: %s\n",fname);
		exit(-1);
	}
	while ((c = getc(ofp)) != EOF)
		putc(c,f);
	fclose(ofp);
}

pr_object(f,p)
FILE *f;
struct psobject *p;
{
	struct psobject **q;
	struct	keyvalpair	*pair;
	int	len;

	switch (p->type) {
		case BOOL:
			fprintf(f,"%s",(p->val.boolval ? "true":"false")); break;
		case FLOAT:
			if (p->val.floatval == (int)p->val.floatval)
				fprintf(f,"%.0f",p->val.floatval); 
			else
				fprintf(f,"%.3f",p->val.floatval); 
			break;
		case NAME:
			fprintf(f,"%s",p->val.str); break;
		case MARK:
			fprintf(f,"mark"); break;
		case STRING:
			fprintf(f,"%s\n",p->val.str); break;
		case ARRAY:
			fprintf(f,"[");
			len = p->val.arr->len;
			q = p->val.arr->val;
			while (len--) {
				if (*q != NULL) {
					pr_object(f,*q);
					fprintf(f," ");
				} else
					fprintf(f,"null ");
				q++;
			}
			fprintf(f,"]"); 
			break;
		case DICT:
			len = ps_dictlen(p);
			fprintf(f,"%d dict begin\n",len);
			pair = p->val.dictdef->first;
			while (pair != NULL) {
				pr_object(f,pair->key);
				fprintf(f,"\t");
				pr_object(f,pair->val);
				fprintf(f,"\tdef\n");
				pair = pair->next;
			}
			fprintf(f,"currentdict end\n");
			break;
	}
}

ps_dictlen(p)
struct psobject *p;
{
	struct keyvalpair *q = p->val.dictdef->first;
	int	n = 0;

	while (q != NULL) {
		n++;
		q = q->next;
	}
	return(n);
}

struct psobject *
ps_get0(p,key,type)
struct psobject *p;
char *key;
{
	struct keyvalpair *q = p->val.dictdef->first;

	while (q != NULL) {
		if ((q->key->type == NAME) && (!strcmp(q->key->val.str,key))) {
			if (q->val->type != type) {
				fprintf(stderr,"Key type error: %s\n",key);
				exit(-1);
			} else
				return(q->val);
		}
		q = q->next;
	}
	return(NULL);
}

struct psobject *
ps_get(p,key,type)
struct psobject *p;
char *key;
{
	struct psobject *obj = ps_get0(p,key,type);

	if (obj == NULL) {
		fprintf(stderr,"Key not found: %s\n",key);
		exit(-1);
	}
	return(obj);
}

generate_drawing(f,p)
FILE *f;
struct psobject *p;
{
	struct psobject *members, **q;
	int	fill = ps_get(p,"Fill?",BOOL)->val.boolval;
	int	stroke = ps_get(p,"Stroke?",BOOL)->val.boolval;
	struct psobject	*linew = ps_get0(p,"LineWidth",FLOAT);
	double lw = ((linew != NULL) ? linew->val.floatval : 1.0);
	int	n;

	members = ps_get(p,"Members",ARRAY);
	n = members->val.arr->len;

	if (fill) connect++;
	q = members->val.arr->val;
	while (n--) {
		if (*q != NULL)
			generate_code(f,*q);
		q++;
	}
	if (fill) connect--;
	if (fill && (!connect)) {
		if (stroke)
			fprintf(f,"%g %s %s SG\n",
				lw,get_color(p,"StrokeColor"),
				get_color(p,"FillColor"));
		else
			fprintf(f,"%s FG\n",get_color(p,"FillColor"));
	}
}

generate_rect(f,p)
FILE *f;
struct psobject *p;
{
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;

	fprintf(f,"%g %g DR\n",w,h);
	generate_draw(f,p);
}

generate_eps(f,p)
FILE *f;
struct psobject *p;
{
	int i;
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;
	struct psobject *obj = ps_get(p,"Program",ARRAY);
	char *creator = ps_get(p,"Creator",STRING)->val.str;
	char *title = ps_get(p,"Title",STRING)->val.str;
	char *date = ps_get(p,"CreationDate",STRING)->val.str;
	struct psobject **b = ps_get(p,"BoundingBox",ARRAY)->val.arr->val;
	double wd = b[2]->val.floatval - b[0]->val.floatval;
	double ht = b[3]->val.floatval - b[1]->val.floatval;

	fprintf(f,"%%%%EPS: %s, %s, %s\n",creator,title,date); 
	if (!connect)
		fprintf(f,"gsave\n");
	fprintf(f,"%g %g DR\n",w,h);
	generate_draw(f,p);
	if (connect)
		return;
	fprintf(f,"grestore\n");
	fprintf(f,"%g %g %g %g BEPS\n",
		-b[0]->val.floatval,
		-b[1]->val.floatval,
		w / wd, h / ht);
	for (i = 0 ; i < obj->val.arr->len ; i++)
		output_object(f,obj->val.arr->val[i]);
	fprintf(f," EEPS\n");
}

generate_rrect(f,p)
FILE *f;
struct psobject *p;
{
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;
	double	c = ps_get(p,"Corner",FLOAT)->val.floatval;

	if (connect) fprintf(f,"CP\n");

	fprintf(f,"%g %g %g RR\n",w,h,c);

	generate_draw(f,p);
}

generate_line(f,p)
FILE *f;
struct psobject *p;
{
	int	stroke = ps_get(p,"Stroke?",BOOL)->val.boolval;
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;
	double	lw = ps_get(p,"LineWidth",FLOAT)->val.floatval;
	int	arr = (int)ps_get(p,"Arrow",FLOAT)->val.floatval;

	if (connect) {
		fprintf(f,"%g %g LC\n",w,h);
		return;
	} else
		fprintf(f,"%g %g LN\n",w,h);
	
	if (stroke) {
		fprintf(f,"%g %s ST\n",lw,get_color(p,"StrokeColor"));

		if (arr & 01)
			fprintf(f,"%s %g %g %g %g AR\n",
				get_color(p,"StrokeColor"),
				10.0 + (lw * 2.0),POINT2ANG(w,h),0.0,0.0);
		if (arr & 02)
			fprintf(f,"%s %g %g %g %g AR\n",
				get_color(p,"StrokeColor"),
				10.0 + (lw * 2.0),POINT2ANG(w,h)+180.0,w,h);
	}
}

generate_text(f,p)
FILE *f;
struct psobject *p;
{
	struct psobject *text = ps_get(p,"Text",ARRAY), **q = text->val.arr->val;
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;
	int	len = 0, n, fill = ps_get(p,"Fill?",BOOL)->val.boolval;
	char *font = ps_get(p,"FontName",NAME)->val.str;
	char *align = ps_get(p,"Align",NAME)->val.str;
	register char *s;

	if (connect) {
		fprintf(f,"%g %g DR\n",w,h);
		return;
	}
	
	if (fill) {
		fprintf(f,"%g %g DR\n",w,h);
		fprintf(f,"%s FL\n",get_color(p,"FillColor"));
	}

	fprintf(f,"[");
	n = text->val.arr->len;
	while (n--) {
		if (*q != NULL) {
			fprintf(f,"(");
			for (s = (*q)->val.str ; *s ; s++) {
				if ((*s == ')') || (*s == '(') || (*s == '\\'))
					fprintf(f,"\\");
				fprintf(f,"%c",*s);
			}
			fprintf(f,")");
		}
		q++;
		len++;
	}
	fprintf(f,"] %s %g /%s SF ",
		get_color(p,"StrokeColor"),(abs(h)/((double)len+0.2)) - 4.0,font);
	fprintf(f,"%g %d TS ",w,((h < 0) ? -1 : 1));
	if (!strcmp(align,"Left")) {
		fprintf(f,"%g %g TL\n",
			(abs(h) - (abs(h)/((double)len+0.2)) + 2),
			-((abs(h)/((double)len+0.2)) - 2));
	} else if (!strcmp(align,"Right")) {
		fprintf(f,"%g %g TR\n",
			(abs(h) - (abs(h)/((double)len+0.2)) + 2),
			-((abs(h)/((double)len+0.2)) - 2));
	} else {
		fprintf(f,"%g %g TC\n",
			(abs(h) - (abs(h)/((double)len+0.2)) + 2),
			-((abs(h)/((double)len+0.2)) - 2));
	}
}

generate_pie(f,p)
FILE *f;
struct psobject *p;
{
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;
	double	d1 = ps_get(p,"d1",FLOAT)->val.floatval;
	double	d2 = ps_get(p,"d2",FLOAT)->val.floatval;

	if (connect) fprintf(f,"closepath\n");
	if (d1 != d2)
		fprintf(f,"%g %g %g %g DP\n",d1,d2,w,h);
	else
		fprintf(f,"%g %g DO\n",w,h);

	generate_draw(f,p);
}

generate_poly(f,p)
FILE *f;
struct psobject *p;
{
	struct psobject *pts = ps_get(p,"Points",ARRAY);
	struct psobject **q = pts->val.arr->val, *first = *q;
	int fill = ps_get(p,"Fill?",BOOL)->val.boolval, n;

	n = pts->val.arr->len;
	if (n > 0) {
		if (fill && connect)
			fprintf(f,"CP\n");
		fprintf(f,"%g %g",first->val.arr->val[0]->val.floatval,
				first->val.arr->val[1]->val.floatval);
		if (connect)
			fprintf(f," PC\n");
		else
			fprintf(f," PT\n");
		while (--n) {
			q++;
			fprintf(f,"%g %g LT\n",
				(*q)->val.arr->val[0]->val.floatval,
				(*q)->val.arr->val[1]->val.floatval);
		}
		if (fill)
			fprintf(f,"%g %g LT CP\n",
				first->val.arr->val[0]->val.floatval,
				first->val.arr->val[1]->val.floatval);
		generate_draw(f,p);
	}
}

generate_spline(f,p)
FILE *f;
struct psobject *p;
{
	struct psobject *pts = ps_get(p,"Points",ARRAY);
	struct psobject **q = pts->val.arr->val;
	int i = 0, m, j, fill = ps_get(p,"Fill?",BOOL)->val.boolval;

	i = pts->val.arr->len;

	if (i > 1) {
		m = i;
		if (fill) {
			if (connect)
				fprintf(f,"CP\n");
			fprintf(f,"%g %g PT\n",
				BETWEENX(i-1,0),BETWEENY(i-1,0));
		} else {
			fprintf(f,"%g %g", POINTX(0), POINTY(0));
			if (connect)
				fprintf(f," PC\n");
			else
				fprintf(f," PT\n");
			m = i-1;
		}
		for (j = 0 ; j < m ; j++)
			fprintf(f,"%g %g %g %g %g %g CT\n",
				POINTX(j), POINTY(j),
				POINTX(j), POINTY(j),
				BETWEENX(j,j+1), BETWEENY(j,j+1));

		if (fill)
			fprintf(f,"CP\n");
		else
			fprintf(f,"%g %g LT\n",POINTX(i-1),POINTY(i-1));
		generate_draw(f,p);
	}
}

generate_arc(f,p)
FILE *f;
struct psobject *p;
{
	int	stroke = ps_get(p,"Stroke?",BOOL)->val.boolval;
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;
	double	lw = ps_get(p,"LineWidth",FLOAT)->val.floatval;
	int	arr = (int)ps_get(p,"Arrow",FLOAT)->val.floatval;
	
	fprintf(f,"%g %g DA\n",w,h);

	if (connect)
		return;
	if (stroke) {
		fprintf(f,"%g %s ST\n",lw,get_color(p,"StrokeColor"));

		if (arr & 01)
			fprintf(f,"%s %g %g %g %g AR\n",
				get_color(p,"StrokeColor"),
				10.0 + (lw * 2.0),((w < 0) ? 180.0 : 0.0),0.0,0.0);
		if (arr & 02)
			fprintf(f,"%s %g %g %g %g AR\n",
				get_color(p,"StrokeColor"),
				10.0 + (lw * 2.0),((h < 0) ? 90.0 : -90.0),w,h);
	}
}

unsigned char *
news_load_pr(file,w,h,d,colmap)
char	*file;
int	*w, *h, *d;
unsigned char *colmap;
{
	extern struct pixrect *pr_load_image();
	extern pr_load_header();
	extern pr_load_colormap();

	int	i;
	FILE *pf;
	struct pixrect *pr;
	struct rasterfile rh;
	colormap_t cm;
	unsigned char red[NCOLS], green[NCOLS], blue[NCOLS];

	/* load pixrect from raster file */

	cm.map[0] = red;
	cm.map[1] = green;
	cm.map[2] = blue;
	cm.length = NCOLS;
	cm.type = 1;

	if ((pf = fopen(file,"r")) == NULL) {
		fprintf(stderr,"cannot open: %s\n",file);
		exit(-1);
	}
	if (pr_load_header(pf,&rh) == PIX_ERR) {
		fprintf(stderr,"not a raster file: %s\n",file);
		exit(-1);
	}
	if ((rh.ras_maplength > 0) && 
	    (pr_load_colormap(pf,&rh,&cm) == PIX_ERR)) {
		fprintf(stderr,"read error (color map): %s\n",file);
		exit(-1);
	}
	if ((pr = pr_load_image(pf,&rh,&cm)) == NULL) {
		fprintf(stderr,"read error (image): %s\n",file);
		exit(-1);
	}
	fclose(pf);
	if ((rh.ras_maptype == RMT_NONE) && (rh.ras_depth > 1)) {
		fprintf(stderr,"no colormap: %s\n",file);
		exit(-1);
	}
	if ((rh.ras_depth != 8) && (rh.ras_depth != 1)) {
		fprintf(stderr,"invalid depth: %s\n",file);
		exit(-1);
	}
	if (rh.ras_depth == 8) {
		/* decode colormap */
		for (i = 0 ; i < NCOLS ; i++) 
			colmap[i] = 0;
		for (i = 0 ; i < cm.length ; i++)
			colmap[i] = ((int)cm.map[0][i]+(int)cm.map[1][i]+
						(int)cm.map[2][i])/3;
	}
	*w = mpr_linebytes(rh.ras_width,rh.ras_depth);
	*h = rh.ras_height;
	*d = rh.ras_depth;
	return((unsigned char *)mpr_d(pr)->md_image);
}

unsigned char *
news_load_icon(file,w,h,d,colmap)
char	*file;
int	*w, *h, *d;
unsigned char *colmap;
{
	int	fd, siz, i;
	char	c, *p;

	if ((fd = open(file,O_RDONLY)) == -1) {
		fprintf(stderr,"cannot open %s\n",file);
		exit(-1);
	}
	if (read(fd,&c,1) != 1) {
		fprintf(stderr,"read error in %s\n",file);
		exit(-1);
	}
	*w = c;
	if (read(fd,&c,1) != 1) {
		fprintf(stderr,"read error in %s\n",file);
		exit(-1);
	}
	*h = c;
	if (read(fd,&c,1) != 1) {
		fprintf(stderr,"read error in %s\n",file);
		exit(-1);
	}
	*d = c;
	if ((*d != 1) && (*d != 8)) {
		fprintf(stderr,"invalid depth %d in %s\n",d,file);
		exit(-1);
	}
	if (*d == 8) {
		for (i = 0 ; i < NCOLS ; i++) 
			colmap[i] = i;
	}

	siz = ((*w) * (*h) * (*d))/8;
	if ((p = (char *)malloc(siz)) == NULL) {
		fprintf(stderr,"cannot allocate %s\n",file);
		exit(-1);
	}
	if (read(fd,p,siz) != siz) {
		fprintf(stderr,"read error in %s\n",file);
		exit(-1);
	}
	close(fd);
	return((unsigned char *)p);
}


unsigned char *
news_load_hips(file,w,h,d,colmap)
char	*file;
int	*w, *h, *d;
unsigned char *colmap;
{
	struct	header hd;
	int	fd, siz;
	unsigned char	c, *p;
	register unsigned char *p1;
	register minp = 255, maxp = 0, i;

	if ((fd = open(file,O_RDONLY)) == -1) {
		fprintf(stderr,"cannot open %s\n",file);
		exit(-1);
	}
	fread_header(fd,&hd);
	*w = hd.cols;
	*h = hd.rows;
	*d = hd.bits_per_pixel;
	if ((*d != 1) && (*d != 8)) {
		fprintf(stderr,"invalid depth %d in %s\n",d,file);
		exit(-1);
	}
	if (*d == 8) {
		for (i = 0 ; i < NCOLS ; i++) 
			colmap[i] = i;
	}

	siz = ((*w) * (*h) * (*d))/8;
	if ((p = (unsigned char *)malloc(siz)) == NULL) {
		fprintf(stderr,"cannot allocate %s\n",file);
		exit(-1);
	}
	if (read(fd,p,siz) != siz) {
		fprintf(stderr,"read error in %s\n",file);
		exit(-1);
	}
	if (*d == 8) {
		/* scale to 0--255 */
		i = siz;
		p1 = p;
		while (i--) {
			if (*p1 < minp)
				minp = *p1;
			if (*p1 > maxp)
				maxp = *p1;
			p1++;
		}
		i = siz;
		p1 = p;
		while (i--) {
			*p1 = ((*p1 - minp)*255)/(maxp-minp);
			p1++;
		}
	}
	close(fd);
	return((unsigned char *)p);
}

unsigned char *
news_load_image(file,w,h,d,colmap)
char	*file;
int	*w, *h, *d;
unsigned char *colmap;
{
	char	*ext = file + strlen(file);

	while ((ext > file) && (*ext != '/') && (*ext != '.')) ext--;
	
	if (*ext == '.') {
		if (!strcmp(ext,".img"))
			return(news_load_pr(file,w,h,d,colmap));
		else if (!strcmp(ext,".icon"))
			return(news_load_icon(file,w,h,d,colmap));
		else return(news_load_hips(file,w,h,d,colmap));
	} else return(news_load_hips(file,w,h,d,colmap));
}

generate_pict(f,p)
FILE *f;
struct psobject *p;
{
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;
	char *ofile = ps_get(p,"PictFile",STRING)->val.str, file[128];
	unsigned char colmap[NCOLS], *q, b;
	int i, llen, x, y, sampleh, samplev, width, height, padlen, depth;
	int	wd, ht;
	double	sh, sv;

	if ((w == 0.0) && (h == 0.0))
		return;

	if (connect) {
		fprintf(f,"%g %g DR\n",w,h);
		return;
	}
	

	news_path_name(ofile,file);

	if (pictalso && lwoutput) {
		q = news_load_image(file,&width,&height,&depth,colmap);
		if ((depth == 8) && ((vscale != 0) || (hscale != 0))) {
			sh = min(1.0,abs(2*hscale*(w/(double)width)));
			sv = min(1.0,abs(2*vscale*(h/(double)height)));
		} else {
			sh = 1.0;
			sv = 1.0;
		}
		sampleh = 1.0/sh;
		samplev = 1.0/sv;
		wd = width;
		ht = height;
		width = width/sampleh;
		height = height/samplev;
		padlen = wd - (width * sampleh);
		llen = ((width*(8/depth)) + 7) / 8;
		fprintf(stderr,"%s, w=%d, h=%d, d=%d\n",file,wd*(8/depth),ht,depth);

		fprintf(f,"%d %d %d %d %d %g %g %g %d IM\n",
			width*(8/depth),height,depth,
			width*(8/depth),-height,
			w,h,h,llen);

		/* output the data */
		i = llen;
		for (y = 0 ; y < height ; y++) {
			for (x = 0 ; x < width ; x++) {
				if (depth > 1)
					b = colmap[*q];
				else
					b = ~(*q);
				if (b < 16)
					fprintf(f,"0%X",b);
				else
					fprintf(f,"%X",b);
				if (!(--i)) {
					i = llen;
					fprintf(f,"\n");
				}
				q += sampleh;
			}
			q += ((samplev-1)*wd) - padlen;
		}
		if (i < llen)
			while (i-- > 0)
				fprintf(f,"FF");
		printf("\n\n");
	} else if (pictalso) {
		fprintf(f,"(%s) %g %g IC\n",file,w,h);
	} else {
		fprintf(f,"%g %g IR\n",w,h);
	}
}

generate_oval(f,p)
FILE *f;
struct psobject *p;
{
	double	w = ps_get(p,"w",FLOAT)->val.floatval;
	double	h = ps_get(p,"h",FLOAT)->val.floatval;

	fprintf(f,"%g %g DO\n",w,h);
	generate_draw(f,p);
}

static int nr = 0;
static char thecol[2][64];

char *get_color(p,nm)
struct psobject *p;
char *nm;
{
	char *str = thecol[nr];
	nr = (nr + 1) % 2;
	p = ps_get(p,nm,ARRAY);

	if (rgbout)
		sprintf(str,"[%g %g %g]",
			p->val.arr->val[0]->val.floatval,
			p->val.arr->val[1]->val.floatval,
			p->val.arr->val[2]->val.floatval);
	else
		sprintf(str,"%g",p->val.arr->val[3]->val.floatval);
	return str;
}

generate_draw(f,p)
FILE *f;
struct psobject *p;
{
	int	fill = ps_get(p,"Fill?",BOOL)->val.boolval;
	int	stroke = ps_get(p,"Stroke?",BOOL)->val.boolval;
	double	lw = ps_get(p,"LineWidth",FLOAT)->val.floatval;

	if (connect)
		return;

	if (stroke) {
		if (fill)
			fprintf(f,"%g %s %s FS\n",lw,get_color(p,"StrokeColor"),
				get_color(p,"FillColor"));
		else
			fprintf(f,"%g %s ST\n",lw,get_color(p,"StrokeColor"));
	} else {
		if (fill)
			fprintf(f,"%s FL\n",get_color(p,"FillColor"));
	}
}
