
#ifndef lint
static char sccsid[] = "@(#)hips.c 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif lint


#include <stdio.h>
#include "hipl_format.h"

/*******************************************************************
	hips
*******************************************************************/

#define LINES 100
#define LINELENGTH 132

static char *ssave[LINES];
static int slmax[LINES];
static int lalloc = 0;

fread_header(fd,hd)

struct header *hd;
int fd;

{
	int lineno, len, i;
	char *s;
	char *getline();

	if(lalloc<1) {
		ssave[0] = (char *)malloc(LINELENGTH);
		slmax[0] = LINELENGTH;
		lalloc = 1;
	}
	getline(fd,&ssave[0],&slmax[0]);
	hd->orig_name = (char *)malloc(strlen(ssave[0])+1);
	strcpy(hd->orig_name,ssave[0]);
	getline(fd,&ssave[0],&slmax[0]);
	hd->seq_name = (char *)malloc(strlen(ssave[0])+1);
	strcpy(hd->seq_name,ssave[0]);
	hd->num_frame = dfscanf(fd);
	getline(fd,&ssave[0],&slmax[0]);
	hd->orig_date = (char *)malloc(strlen(ssave[0])+1);
	strcpy(hd->orig_date,ssave[0]);
	hd->rows = dfscanf(fd);
	hd->cols = dfscanf(fd);
	hd->bits_per_pixel = dfscanf(fd);
	hd->bit_packing = dfscanf(fd);
	hd->pixel_format = dfscanf(fd);
	lineno = 0;
	len = 1;
	getline(fd,&ssave[0],&slmax[0]);
	s = ssave[0];
	while(*(s += strlen(s)-3) == '|') {
		len += strlen(ssave[lineno]);
		lineno++;
		if (lineno >= LINES) {
			fprintf(stderr,"Too many lines in header history\n");
			exit(1);
		}
		if(lineno >= lalloc) {
			ssave[lineno] = (char *)malloc(LINELENGTH);
			slmax[lineno] = LINELENGTH;
			lalloc++;
		}
		getline(fd,&ssave[lineno],&slmax[lineno]);
		s = ssave[lineno];
	}
	len += strlen(ssave[lineno]);
	hd->seq_history = (char *)malloc(len);
	hd->seq_history[0] = '\0';
	for (i=0;i<=lineno;i++)
		strcat(hd->seq_history,ssave[i]);
	lineno = 0;
	len = 1;
	while(strcmp(getline(fd,&ssave[lineno],&slmax[lineno]),".\n")) {
		len += strlen(ssave[lineno]);
		lineno++;
		if (lineno >= LINES) {
			fprintf(stderr,"Too many lines in header desc.\n");
			exit(1);
		}
		if(lineno >= lalloc) {
			ssave[lineno] = (char *)malloc(LINELENGTH);
			slmax[lineno] = LINELENGTH;
			lalloc++;
		}
	}
	hd->seq_desc = (char *)malloc(len);
	*hd->seq_desc = '\0';
	for (i=0;i<lineno;i++)
		strcat(hd->seq_desc,ssave[i]);
}

char *getline(fd,s,l)

char **s;
int fd;
int *l;

{
	int i,m;
	char c,*s1,*s2;

	i = 0;
	s1 = *s;
	m = *l;
	while(read(fd,&c,1) == 1 && c != '\n') {
		if (m-- <= 2) {
			s2 = (char *)malloc(LINELENGTH+*l);
			strcpy(s2,*s);
			*s = s2;
			*l += LINELENGTH;
			m = LINELENGTH;
			s1 = s2 + strlen(s2);
		}
		*s1++ = c;
	}
	if (c == '\n') {
		*s1++ = '\n';
		*s1 = '\0';
		return(*s);
	}
	fprintf(stderr,"Unexpected EOF while reading header.\n");
	exit(1);
}

dfscanf(fd)

int fd;

{
	int i;

	getline(fd,&ssave[0],&slmax[0]);
	sscanf(ssave[0],"%d",&i);
	return(i);
}

pread(fd,p,n)
int fd, n;
char *p;
{
	int 	m;

	while (n) {
		if ((m = read(fd,p,n)) < 0)
			return(-1);
		n -= m;
		p += m;
	}
}

read_header(hd)
struct header *hd;
{
	fread_header(0,hd);
}
