
/* "@(#)psdata.h 3.1 3/19/90 Arthur van Hoff (Turing Institute)"; */


#define	FALSE		0
#define	TRUE		1

#define max(a,b)	(((a) > (b)) ? (a) : (b))
#define min(a,b)	(((a) < (b)) ? (a) : (b))

#define	DICT		0
#define	ARRAY		1
#define	FLOAT		2
#define	NAME		3
#define	STRING		4
#define	MARK		5
#define	BOOL		6
#define	NILL		7
#define	OPERATOR	8
#define	STREAM		9

struct array_def {
	unsigned short	len;
	struct	psobject *val[10000];
};

struct file_def {
	FILE	*fp;
	unsigned short   ln, col;
	char 	*name;
};

struct keyvalpair {
	struct psobject *key;
	struct psobject *val;
	struct keyvalpair *next;
	struct keyvalpair *hash;
	struct keyvalpair *coll;
};

struct dictdef {
	int	maxlen;
	struct keyvalpair *first;
	struct keyvalpair *free;
	struct keyvalpair *pair;
};

struct psobject {
	unsigned char 	type;
	unsigned char	exec;
	unsigned short	ref;
	union {
		/* dictionary */
		struct dictdef *dictdef;

		/* array */
		struct array_def *arr;

		/* array */
		unsigned char boolval;

		/* float */
		double		floatval;

		/* name, string */
		char		*str;

		/* operator */
		int	(*proc)();

		/* file */
		struct file_def *file;
	} val;
};

extern char *stralloc();
extern struct psobject *new_object();
extern struct psobject *new_dict();
extern struct psobject *pop();
extern struct psobject *get_token();
extern struct psobject *dict_where();
extern struct keyvalpair *dict_search();
extern struct keyvalpair *dict_lookup();
extern push();
extern dict_begin();
extern dict_end();

extern int trace, breakflag;
extern struct psobject **psstack, **stack;
extern struct psobject *currentdict, *systemdict, *currentfile;
