%{
#ifndef lint
static char sccsid[] = "@(#)token.l 3.2 9/21/90 Arthur van Hoff (Turing Institute)";
#endif lint

#include <stdio.h>
#include "psdata.h"

#define	yywrap()	1
#undef getc
#define getc(fp)	read_char_from_file()

extern float atof();
%}

A	[a-zA-Z!@#$^&*_+=|~`:;,.?-]
D	[0-9]

%%
"%".*$		{}
"<"[0-9A-Fa-f]*">"		{
		struct psobject *obj = new_object(STRING);
		char *s1 = yytext+1, *s2 = yytext+1;
		int n = (strlen(yytext)-2)/2;
		while (n--) {
			if (*s1 >= 'a') *s2 = (*s1 - 'a' + 10) * 16;
			else if (*s1 >= 'A') *s2 = (*s1 - 'A' + 10) * 16;
			else if (*s1 >= '0') *s2 = (*s1 - '0') * 16;
			s1++;
			if (*s1 >= 'a') *s2 += (*s1 - 'a' + 10);
			else if (*s1 >= 'A') *s2 += (*s1 - 'A' + 10);
			else if (*s1 >= '0') *s2 += (*s1 - '0');
			s1++; s2++;
		}
		*s2 = '\0';
		obj->val.str = stralloc(yytext+1);
		return((int)obj);
	}
"("("\\\)"|"\n"|[^\)])*")"	{
		struct psobject *obj = new_object(STRING);
		char *s1 = yytext+1, *s2 = yytext+1;
		yytext[strlen(yytext)-1] = '\0';
		while (*s2 = *s1) {
			if (*s1 == '\\') {
				switch (*++s1) {
					case 'n': *s2 = '\n'; break;
					case 't': *s2 = '\t'; break;
					case '\n': s2--; break;
					default: *s2 = *s1;
				}
			} 
			s1++; 
			s2++;
		}
		obj->val.str = stralloc(yytext+1);
		return((int)obj);
	}
(([-]?{D}*"."{D}+([eE][-]?{D}+)?)|([-]?{D}+("."{D}*)?([eE][-]?{D}+)?)) {
		struct psobject *obj = new_object(FLOAT);
		obj->val.floatval = atof(yytext);
		return((int)obj);
	}
"/"({A}|[\[\]\{\}])({A}|{D})*		{
		struct psobject *obj = new_object(NAME);
		obj->val.str = stralloc(yytext+1);
		return((int)obj);
	}
({A}({A}|{D})*|[\[\]\{\}])	{
		struct psobject *obj = new_object(NAME);
		obj->val.str = stralloc(yytext);
		obj->exec = TRUE;
		return((int)obj);
	}
[ \t\n]				{}
.				{}
%%

struct psobject *
get_token()
{
	yyin = currentfile->val.file->fp;
	return((struct psobject *)yylex());
}
