
#ifndef lint
static char sccsid[] = "@(#)draw.c 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif lint


#include <stdio.h>

FILE	*dfp	= stdout;
float	linewidth, fillcolor, strokecolor, textcolor;
int	linearrow;
char	*font;
int	glevel = 0;

line_arrow(v)
int v;
{
	linearrow = v;
}

line_width(v)
float v;
{
	linewidth = v;
}

fill_color(v)
float v;
{
	fillcolor = v;
}

stroke_color(v)
float v;
{
	strokecolor = v;
}

text_color(v)
float v;
{
	textcolor = v;
}

text_font(f)
char	*f;
{
	font = f;
}

line(x1,y1,x2,y2)
float	x1,y1,x2,y2;
{
	fprintf(dfp,"MX %.3g %.3g %.3g %.3g ",
		x1,y1,x2,y2);
	fprintf(dfp,"true %.3g %.3g %.3g %.3g ",
		strokecolor,strokecolor,strokecolor,strokecolor);
	fprintf(dfp,"false WH %.3g 0 LI\n",linewidth);
}

circle(x,y,w,h,stroke,fill)
float	x, y, w, h;
{
	fprintf(dfp,"MX %.3g %.3g %.3g %.3g ",
		x,y,w,h);
	fprintf(dfp,"%s %.3g %.3g %.3g %.3g ",
		(stroke ? "true" : "false"),
		strokecolor,strokecolor,strokecolor,strokecolor);
	fprintf(dfp,"%s %.3g %.3g %.3g %.3g ",
		(fill ? "true" : "false"),
		fillcolor,fillcolor,fillcolor,fillcolor);
	fprintf(dfp,"%.3g OV\n",linewidth);
}

rect(x,y,w,h,stroke,fill)
float	x, y, w, h;
{
	fprintf(dfp,"MX %.3g %.3g %.3g %.3g ",
		x,y,w,h);
	fprintf(dfp,"%s %.3g %.3g %.3g %.3g ",
		(stroke ? "true" : "false"),
		strokecolor,strokecolor,strokecolor,strokecolor);
	fprintf(dfp,"%s %.3g %.3g %.3g %.3g ",
		(fill ? "true" : "false"),
		fillcolor,fillcolor,fillcolor,fillcolor);
	fprintf(dfp,"%.3g RE\n",linewidth);
}

text(str,x,y,w,h)
char	*str;
float	x, y, w, h;
{
	fprintf(dfp,"MX %.3g %.3g %.3g %.3g ",
		x,y,w,h);
	fprintf(dfp,"true BL ");
	fprintf(dfp,"false WH ");
	fprintf(dfp,"1 %s /Left [(",font);
	while (*str) {
		if ((*str == '(') || (*str == ')'))
			fprintf(dfp,"\\");
		fprintf(dfp,"%c",*str++);
	}
	fprintf(dfp,")] TE\n");
}

vtext(str,x,y,w,h)
char	*str;
float	x, y, w, h;
{
	fprintf(dfp,"0 1 -1 0  %.3g %.3g %.3g %.3g ",
		x,y,w,h);
	fprintf(dfp,"true BL ");
	fprintf(dfp,"false WH ");
	fprintf(dfp,"1 /%s /Left [(",font);
	while (*str) {
		if ((*str == '(') || (*str == ')'))
			fprintf(dfp,"\\");
		fprintf(dfp,"%c",*str++);
	}
	fprintf(dfp,")] TE\n");
}

start_group(w,h)
float	w, h;
{
	if (!glevel++)
		fprintf(dfp,"BeginDrawing\n");

	fprintf(dfp,"MX 0 0 %.3g %.3g ",
		w,h);
	fprintf(dfp,"false BL ");
	fprintf(dfp,"false WH ");
	fprintf(dfp,"1 DR [\n");
}

end_group()
{

        fprintf(dfp,"] ME\n");
	if (!--glevel)
		fprintf(dfp,"EndDrawing\n");
}
