%{
/* "@(#)parse.l 3.1 3/19/90 Arthur van Hoff (Turing Institute)"; */

	/* plot input parser */

	float	numval;
	char	*stralloc();
	int	ln = 0;

%}

%%

[-+]*[0-9]+				{ 
	sscanf(yytext,"%f",&yylval.f); return(NUM); }
[-+]*[0-9]*"."[0-9]*			{
	sscanf(yytext,"%f",&yylval.f); return(NUM); }
[-+]*[0-9]+[eE][-+]*[0-9]+		{
	sscanf(yytext,"%f",&yylval.f); return(NUM); }
[-+]*[0-9]*"."[0-9]*[eE][-+]*[0-9]+	{
	sscanf(yytext,"%f",&yylval.f); return(NUM); }
[\"\'].*[\"\']				{
		yytext[strlen(yytext)-1] = '\0';
		yylval.str = stralloc(yytext+1);
		return(STRING);
	}
"color"		{ return(COLOR); }
"sort"		{ return(SORT); }
"line"		{ return(LINE); }
"thinline"	{ return(THINLINE); }
"dots"		{ return(DOTS); }
"smalldots"	{ return(SMALLDOTS); }
"cross"		{ return(CROSS); }
"blocks"	{ return(BLOCKS); }
"from"		{ return(FROM); }
"to"		{ return(TO); }
"ticks"		{ return(TICKS); }
"lines"		{ return(LINES); }
"bars"		{ return(BARS); }
"numbers"	{ return(NUMBERS); }
"label"		{ return(LABEL); }
"title"		{ return(TITLE); }
"data"		{ return(DATA); }
"xaxis"		{ return(XAXIS); }
"yaxis"		{ return(YAXIS); }
"height"	{ return(HEIGHT); }
"width"		{ return(WIDTH); }
"true"		{ return(TRUE); }
"false"		{ return(FALSE); }
[ 	,;:()[]|]*			{ return(yylex());}
^\%.*"\n"				{ ln++; return(yylex());}
"\n"					{ ln++; return(yylex());}
.					{ return(*yytext); }

%%

char *
stralloc(str)
char *str;
{
	char *s = (char *)malloc(strlen(str)+1);
	strcpy(s,str);
	return(s);
}

yywrap()
{
	return(1);
}

yyerror(str)
char *str;
{
	fprintf(stderr,"**** %s **** near line %d.\n",str,ln);
}

