
%{
#ifndef lint
static char sccsid[] = "@(#)parse.y 3.1 3/19/90 Arthur van Hoff (Turing Institute)";
#endif lint

#include	<stdio.h>

#define VEXTRA		(float)50.0
#define HEXTRA		(float)35.0
#define TICKLENGTH	(float)2.0
#define FONT		"/Helvetica"
#define FONTSIZE	(float)10.0
#define	STRWIDTH(str)	(float)((strlen(str)*3.5)+3.0)

#define	XPOS(i)		(float)(VEXTRA + (((i-xfrom)*width)/(xto-xfrom)))
#define	YPOS(i)		(float)(HEXTRA + (((i-yfrom)*height)/(yto-yfrom)))

#define YYSTYPE	YYUNION
	struct	{
		float	x, y;
		char	*label;
	}	data[512];

	char	*title	=	NULL,
		*xlabel	=	NULL,
		*ylabel =	NULL,
		*filename = 	NULL;
	float	height	=	350.0,
		width	=	450.0,
		xfrom 	= 	0,
		xto	=	0,
		xticks	=	-1,
		xnums	=	-1,
		xlines	=	-1,
		yfrom 	= 	0,
		yto	=	0,
		yticks	=	-1,
		ynums	=	-1,
		ylines	=	-1,
		color	=	0.0;
	int	n, linetp, bartp, dottp, sort;
%}

%start plot

%union {
	float	f;
	char	*str;
}

%token	NUM TRUE FALSE TITLE STRING HEIGHT WIDTH XAXIS YAXIS
%token	FROM TO TICKS LINES NUMBERS LABEL 
%token	DATA LINE THINLINE BARS DOTS SMALLDOTS CROSS BLOCKS SORT COLOR

%%

plot	:	header 	{ 
				start_group(width+VEXTRA+10.0,height+HEXTRA+50.0);
				generate_axis(); 
			}
		data	
			{	end_group(); }
	;

header	:	gheader xheader yheader 	
	;

gheader :
	|	gheader	TITLE '=' STRING {title = $4.str;}
	|	gheader	HEIGHT '=' NUM {height = $4.f;}
	|	gheader	WIDTH '=' NUM {width = $4.f;}
	;

xheader :	XAXIS xspec
	;

xspec	:
	|	xspec LABEL '=' STRING {xlabel = $4.str;}
	|	xspec FROM '=' NUM {xfrom = $4.f;}
	|	xspec TO '=' NUM {xto = $4.f;}
	|	xspec TICKS '=' NUM {xticks = $4.f;}
	|	xspec NUMBERS '=' NUM {xnums = $4.f;}
	|	xspec LINES '=' NUM {xlines = $4.f;}
	;

yheader :	YAXIS yspec
	;

yspec	:
	|	yspec LABEL '=' STRING {ylabel = $4.str;}
	|	yspec FROM '=' NUM {yfrom = $4.f;}
	|	yspec TO '=' NUM {yto = $4.f;}
	|	yspec TICKS '=' NUM {yticks = $4.f;}
	|	yspec NUMBERS '=' NUM {ynums = $4.f;}
	|	yspec LINES '=' NUM {ylines = $4.f;}
	;

data	: 
	| 	data dataset	
	;

dataset	:	DATA { 
			sort = 0;
			color = 0.0;
			n = 0;
			linetp = 0;
			bartp = 0;
			dottp = 0;
		}
		plotsp xylist	{ generate_data(); }
	;

plotsp	:	
	|	plotsp	LINE		{ linetp = LINE; }
	|	plotsp	THINLINE	{ linetp = THINLINE; }
	|	plotsp	BARS		{ bartp = BARS; }
	|	plotsp	DOTS		{ dottp = DOTS; }
	|	plotsp	SMALLDOTS	{ dottp = SMALLDOTS; }
	|	plotsp	CROSS		{ dottp = CROSS; }
	|	plotsp	BLOCKS		{ dottp = BLOCKS; }
	|	plotsp	SORT		{ sort = 1; }
	|	plotsp	COLOR '=' NUM	{ color = $4.f; }
	;

xylist	:
	|	xylist NUM NUM 	
			{data[n].x = $2.f; data[n].y = $3.f; data[n++].label = NULL;}
	|	xylist NUM NUM STRING
			{data[n].x = $2.f; data[n].y = $3.f; data[n++].label = $4.str; }
	;
	
%%

#include "parsel.h"

f2s(str,v)
char *str;
float	v;
{
	char    *p;

	v = ((int)(v*1000.0))/1000.0;

        if (v == (int)v)
                sprintf(str,"%d",(int)v);
        else {
                sprintf(str,"%f",v);
                p = str + strlen(str) - 1;
                while (*p == '0') *p-- = '\0';
        }
}

generate_axis()
{
	float	i, j;
	char	str[128];

	if (xticks < 0)
		xticks = (xto - xfrom) / 5.0;
	if (yticks < 0)
		yticks = (yto - yfrom) / 5.0;
	if (xnums < 0)
		xnums = xticks;
	if (ynums < 0)
		ynums = yticks;

	line_width(1.0);
	stroke_color(0.0);
	fill_color(1.0);
	text_color(0,0);
	text_font(FONT);

	/* generate X-lines */
	if (xlines > 0) {
		line_width(0.5);
		stroke_color(0.8);
		i = xfrom + xlines;
		while (i <= xto) {
			line(XPOS(i),HEXTRA,0.0,height);
			i += xlines;
		}
		stroke_color(0.0);
		line_width(1.0);
	}

	/* generate X axis */
	line(VEXTRA,HEXTRA,width,0.0);

	/* generate X-ticks */
	i = xfrom;
	while (i <= xto) {
		if (((int)((i-xfrom)/xnums)) != ((i-xfrom)/xnums))
			line(XPOS(i),HEXTRA,0.0,-TICKLENGTH);
		i += xticks;
	}

	/* generate X-numbers */
	i = xfrom;
	while (i <= xto) {
		f2s(str,i);
		line(XPOS(i),HEXTRA,0.0,-(TICKLENGTH+2));
		text(str,XPOS(i)-(STRWIDTH(str)/2.0),HEXTRA-20.0,STRWIDTH(str),16.0);
		i += xnums;
	}


	/* generate X-label */
	if (xlabel != NULL) {
		text_font("/Courier-Oblique");
		text(xlabel,VEXTRA+width - 20.0 - (strlen(xlabel)*5.0),
			0.0,(float)(strlen(xlabel)*5.0),15.0);
		text_font(FONT);
	}

	/* generate Y-lines */
	if (ylines > 0) {
		line_width(0.5);
		stroke_color(0.8);
		i = yfrom + ylines;
		while (i <= yto) {
			line(VEXTRA,YPOS(i),width,0.0);
			i += ylines;
		}
		stroke_color(0.0);
		line_width(1.0);
	}

	/* generate Y axis */
	line(VEXTRA,HEXTRA,0.0,height);

	/* generate Y-ticks */
	i = yfrom;
	while (i <= yto) {
		if (((int)((i-yfrom)/ynums)) != ((i-yfrom)/ynums))
			line(VEXTRA,YPOS(i),-TICKLENGTH,0.0);
		i += yticks;
	}

	/* generate Y-numbers */
	j = 0.0;
	i = yfrom;
	while (i <= yto) {
		f2s(str,i);
		if (j < STRWIDTH(str))
			j = STRWIDTH(str);
		i += ynums;
	}
	j = VEXTRA - j - 5.0;

	i = yfrom;
	while (i <= yto) {
		f2s(str,i);
		line(VEXTRA,YPOS(i),-(TICKLENGTH+2.0),0.0);
		text(str,j,YPOS(i)-7.0,STRWIDTH(str),16.0);
		i += ynums;
	}

	/* generate Y-label */
	/* generate X-label */
	if (ylabel != NULL) {
		text_font("/Courier-Oblique");
		vtext(ylabel,j - 5.0,HEXTRA+height - 20.0 - (strlen(ylabel)*5.0),
			(float)(strlen(ylabel)*5.0),15.0);
		text_font(FONT);
	}

	/* generate the title */

	if ((!title) && filename) {
		sprintf(str,"file: %s",filename);
		title = str;
	}

	if (title) {
		text_font("/Courier-Bold");
		text(title,VEXTRA + (width/2.0) - (strlen(title)*3.0),
			height+HEXTRA, (float)(strlen(title)*6.0),30.0);
		text_font(FONT);
	}
}

sort_data()
{
	int	i, ready;
	float	f;
	char	*s;

	do {
		ready = 1;
		for (i = 1 ; i < n ; i++) {
			if (data[i-1].x > data[i].x) {
				f = data[i-1].x;
				data[i-1].x = data[i].x;
				data[i].x = f;
				f = data[i-1].y;
				data[i-1].y = data[i].y;
				data[i].y = f;
				s = data[i-1].label;
				data[i-1].label = data[i].label;
				data[i].label = s;
				ready = 0;
			}
		}
	} while (!ready);

}

generate_bars()
{
	int	i;
	float	x,x2;

	if (n < 2)
		return;

	stroke_color(0.0);
	if (color == 0.0)
		fill_color(0.8);
	x = VEXTRA;
	x2 = XPOS(data[0].x - ((data[1].x - data[0].x)/2.0));
	if (x2 > x)
		x = x2;
	for (i = 0 ; i < (n-1) ; i++) {
		x2 = (XPOS(data[i].x)+XPOS(data[i+1].x)) / 2.0;
		rect(x,HEXTRA,x2-x,YPOS(data[i].y)-HEXTRA,1,1);
		x = x2;
	}
	x2 = (XPOS(data[n-1].x) - x) * 2.0;
	rect(x,HEXTRA,x2,YPOS(data[n-1].y)-HEXTRA,1,1);
	
	stroke_color(color);
	fill_color(color);
}

generate_line()
{
	float	x,y;
	int	i;

	if (n <= 1)
		return;

	x = XPOS(data[0].x);
	y = YPOS(data[0].y);

	for (i = 1 ; i < n ; i++) {
		line(x,y, XPOS(data[i].x)-x,YPOS(data[i].y)-y);
		x = XPOS(data[i].x);
		y = YPOS(data[i].y);
	}
}

generate_dots()
{
	int	i;
	float	x,y;

	line_width(0.3);
	for (i = 0 ; i < n ; i ++) {
		x = XPOS(data[i].x);
		y = YPOS(data[i].y);
		switch (dottp) {
			case	DOTS:
				circle(x-2.0,y-2.0,4.0,4.0,0,1);
				break;
			case 	SMALLDOTS:
				circle(x-1.0,y-1.0,2.0,2.0,0,1);
			case	CROSS:
				line(x-2.0,y,4.0,0.0);
				line(x,y-2.0,0.0,4.0);
				break;
			case	BLOCKS:
				rect(x-2.0,y-2.0,4.0,4.0,0,1);
				break;
		}
	}
	line_width(1.0);
}

generate_labels()
{
	int	i;

	for (i = 0 ; i < n ; i ++)
		if (data[i].label != NULL) {
			text_font("/Courier");
			text(data[i].label,
				XPOS(data[i].x),
				YPOS(data[i].y),
				(float)(strlen(data[i].label)*6.0),15.0);
			text_font(FONT);
		}
}

generate_data()
{
	stroke_color(color);
	fill_color(color);

	if (n == 0)
		return;
	if (sort)
		sort_data();
	if (bartp)
		generate_bars();
	if (linetp) {
		if (linetp == THINLINE)
			line_width(0.3);
		generate_line();
		line_width(1.0);
	}
	if (dottp) 
		generate_dots();
	generate_labels();
}

main(argc,argv)
char	*argv[];
{
	FILE *fp;

	if (argc != 1) {
		if (argc > 2) {
			fprintf(stderr,"too many args\n");
			exit(-1);
		}
		if ((fp = (FILE *)fopen(argv[1],"r")) == NULL) {
			fprintf(stderr,"cannot open: %s\n",argv[1]);
			exit(-1);
		}
		yyin = fp;
		filename = argv[1];
	}
	yyparse();
}
